# 2008/11/24 元になるエッジを非表示にするようにした
# 2008/7/7 元になるエッジを消去するようにした
# 2008/2/24 グループ化出来るようにした
#           文字コードUTF-8で日本語が表示できるようにした
#
# Original RSfence.rb 2008.1.25 Hino 
# 改変，再配布に制限はありません。
# 使用者の自己責任でご使用下さい。
# 改造及び配布に制限はありません。

require 'sketchup.rb'
require 'extensions.rb'
class RSfence
def louver
  #天端
  $k1taka=110.cm if not $k1taka
  #未使用
  @k1keijo='□'
  #手摺（握り部）の巾
  $k1W=60.mm
  #手摺（握り部）のせい
  $k1H=4.mm
  #天端から上胴縁までの空き
  $k2taka=0.cm
  #未使用
  $k2keijo='□'
  #上胴縁の巾(これをゼロにすると書かない)
  $k2W=0.cm
  #上胴縁のせい
  $k2H=0.mm
  #下胴縁の、下端からの高さ
  $k3taka=0.cm
  #未使用
  $k3keijo='□'
  #下胴縁の巾(これをゼロにすると書かない)
  $k3W=0.cm
  #下胴縁のせい
  $k3H=0.mm
  #隅柱の見附
  $ksumiW=0.cm
  #隅柱の見込み
  $ksumiD=0.cm
  #間柱のピッチ(これに近い値で均等割り付け）
  $knakaP=0.cm
  #間柱の見附
  $knakaW=0.cm
  #間柱の見込み
  $knakaD=0.cm
  #手摺子のタイプ（横"border"  縦"stripe"  パネル"panel"  縦交差"cross"  メッシュ"mesh"
  @ksan="border"
  #中桟のピッチ(これに近い値で均等割り付け）
  $ksanP=60.mm
  #中桟のせい（横桟はせい，縦桟は見附）
  $ksanH=4.mm
  #中桟の見込み
  $ksanD=60.mm
  handrails()
end

def yokosan1
  $k1taka=110.cm if not $k1taka
  @k1keijo='□'
  $k1W=7.cm
  $k1H=45.mm
  $k2taka=0.cm
  $k2keijo='□'
  $k2W=0.cm
  $k2H=0.mm
  $k3taka=0.cm
  $k3keijo='□'
  $k3W=0.cm
  $k3H=0.mm
  $ksumiW=6.cm
  $ksumiD=6.cm
  $knakaP=180.cm
  $knakaW=3.cm
  $knakaD=6.cm
  @ksan="border"
  $ksanP=6.cm
  $ksanH=1.cm
  $ksanD=4.cm
  handrails()
end

def yokosan2
  $k1taka=110.cm if not $k1taka
  @k1keijo='□'
  $k1W=7.cm
  $k1H=45.mm
  $k2taka=0.cm
  $k2keijo='□'
  $k2W=0.cm
  $k2H=0.mm
  $k3taka=15.cm
  $k3keijo='□'
  $k3W=5.cm
  $k3H=25.mm
  $ksumiW=6.cm
  $ksumiD=6.cm
  $knakaP=180.cm
  $knakaW=3.cm
  $knakaD=6.cm
  @ksan="border"
  $ksanP=6.cm
  $ksanH=1.cm
  $ksanD=4.cm
  handrails()
end

def yokosan3
  $k1taka=110.cm if not $k1taka
  @k1keijo='□'
  $k1W=7.cm
  $k1H=45.mm
  $k2taka=15.cm
  $k2keijo='□'
  $k2W=5.cm
  $k2H=25.mm
  $k3taka=15.cm
  $k3keijo='□'
  $k3W=5.cm
  $k3H=25.mm
  $ksumiW=6.cm
  $ksumiD=6.cm
  $knakaP=180.cm
  $knakaW=3.cm
  $knakaD=6.cm
  @ksan="border"
  $ksanP=6.cm
  $ksanH=1.cm
  $ksanD=4.cm
  handrails()
end

def yokosan4
  $k1taka=80.cm if not $k1taka
  @k1keijo='□'
  $k1W=44.mm
  $k1H=12.mm
  $k2taka=0.cm
  $k2keijo='□'
  $k2W=0.cm
  $k2H=0.mm
  $k3taka=0.cm
  $k3keijo='□'
  $k3W=0.cm
  $k3H=0.mm
  $ksumiW=12.mm
  $ksumiD=44.mm
  $knakaP=250.cm
  $knakaW=12.mm
  $knakaD=44.mm
  @ksan="border"
  $ksanP=20.cm
  $ksanH=9.mm
  $ksanD=44.mm
  handrails()
end

def tatesan1
  $k1taka=110.cm if not $k1taka
  @k1keijo='□'
  $k1W=7.cm
  $k1H=45.mm
  $k2taka=0.cm
  $k2keijo='□'
  $k2W=0.cm
  $k2H=0.mm
  $k3taka=0.cm
  $k3keijo='□'
  $k3W=0.cm
  $k3H=0.mm
  $ksumiW=6.cm
  $ksumiD=6.cm
  $knakaP=180.cm
  $knakaW=3.cm
  $knakaD=6.cm
  @ksan="stripe"
  $ksanP=10.cm
  $ksanH=1.cm
  $ksanD=4.cm
  handrails()
end

def tatesan2
  $k1taka=110.cm if not $k1taka
  @k1keijo='□'
  $k1W=7.cm
  $k1H=45.mm
  $k2taka=0.cm
  $k2keijo='□'
  $k2W=0.cm
  $k2H=0.mm
  $k3taka=15.cm
  $k3keijo='□'
  $k3W=5.cm
  $k3H=25.mm
  $ksumiW=6.cm
  $ksumiD=6.cm
  $knakaP=180.cm
  $knakaW=3.cm
  $knakaD=6.cm
  @ksan="stripe"
  $ksanP=10.cm
  $ksanH=1.cm
  $ksanD=4.cm
  handrails()
end

def tatesan3
  $k1taka=110.cm if not $k1taka
  @k1keijo='□'
  $k1W=7.cm
  $k1H=45.mm
  $k2taka=15.cm
  $k2keijo='□'
  $k2W=5.cm
  $k2H=25.mm
  $k3taka=15.cm
  $k3keijo='□'
  $k3W=5.cm
  $k3H=25.mm
  $ksumiW=6.cm
  $ksumiD=6.cm
  $knakaP=180.cm
  $knakaW=3.cm
  $knakaD=6.cm
  @ksan="stripe"
  $ksanP=10.cm
  $ksanH=1.cm
  $ksanD=4.cm
  handrails()
end

def panel1
  $k1taka=110.cm if not $k1taka
  @k1keijo='□'
  $k1W=7.cm
  $k1H=45.mm
  $k2taka=15.cm
  $k2keijo='□'
  $k2W=5.cm
  $k2H=25.mm
  $k3taka=15.cm
  $k3keijo='□'
  $k3W=5.cm
  $k3H=25.mm
  $ksumiW=6.cm
  $ksumiD=6.cm
  $knakaP=120.cm
  $knakaW=3.cm
  $knakaD=6.cm
  @ksan="panel"
  $ksanP=0.cm
  $ksanH=0.cm
  $ksanD=1.cm
  handrails()
end

def cross1
  #天端
  $k1taka=110.cm if not $k1taka
  #未使用
  @k1keijo='□'
  #手摺（握り部）の巾
  $k1W=6.cm
  #手摺（握り部）のせい
  $k1H=6.cm
  #天端から上胴縁までの空き
  $k2taka=0.cm
  #未使用
  $k2keijo='□'
  #上胴縁の巾(これをゼロにすると書かない)
  $k2W=0.cm
  #上胴縁のせい
  $k2H=0.mm
  #下胴縁の、下端からの高さ
  $k3taka=15.cm
  #未使用
  $k3keijo='□'
  #下胴縁の巾(これをゼロにすると書かない)
  $k3W=5.cm
  #下胴縁のせい
  $k3H=5.cm
  #隅柱の見附
  $ksumiW=55.mm
  #隅柱の見込み
  $ksumiD=55.mm
  #間柱のピッチ(これに近い値で均等割り付け）
  $knakaP=180.cm
  #間柱の見附
  $knakaW=55.mm
  #間柱の見込み
  $knakaD=55.mm
  #手摺子のタイプ（横"border"  縦"stripe"  パネル"panel"  縦交差"cross"  メッシュ"mesh"
  @ksan="cross"
  #中桟のピッチ(縦交差の垂直ピッチ）
  $ksanP=5.cm
  #中桟のせい（縦交差の水平ピッチ）
  $ksanH=12.cm
  #中桟の見込み
  $ksanD=5.cm
  handrails()
end

def mesh1
  #天端
  $k1taka=110.cm if not $k1taka
  #未使用
  @k1keijo='□'
  #手摺（握り部）の巾
  $k1W=6.cm
  #手摺（握り部）のせい
  $k1H=6.cm
  #天端から上胴縁までの空き
  $k2taka=0.cm
  #未使用
  $k2keijo='□'
  #上胴縁の巾(これをゼロにすると書かない)
  $k2W=0.cm
  #上胴縁のせい
  $k2H=0.mm
  #下胴縁の、下端からの高さ
  $k3taka=15.cm
  #未使用
  $k3keijo='□'
  #下胴縁の巾(これをゼロにすると書かない)
  $k3W=5.cm
  #下胴縁のせい
  $k3H=5.cm
  #隅柱の見附
  $ksumiW=55.mm
  #隅柱の見込み
  $ksumiD=55.mm
  #間柱のピッチ(これに近い値で均等割り付け）
  $knakaP=180.cm
  #間柱の見附
  $knakaW=55.mm
  #間柱の見込み
  $knakaD=55.mm
  #手摺子のタイプ（横"border"  縦"stripe"  パネル"panel"  縦交差"cross"  メッシュ"mesh"
  @ksan="mesh"
  #メッシュの横ピッチ
  $ksanP=8.cm
  #メッシュの縦ピッチ
  $ksanH=5.cm
  #不使用
  $ksanD=10.cm
  handrails()
end

def handrails
  model = Sketchup.active_model
  model.start_operation "RS横大和塀"
  entities = model.active_entities
  ss = model.selection
  
  if ss.empty? 
    UI.messagebox("请选择线")
    return nil
  end
  
  prompts=["高度"]
  values=[$k1taka]
  results=inputbox prompts, values, "输入"
  return if not results
  $k1taka=results[0]
 
 #線要素だけ拾い出し
  others = 0
  lines = 0
  
  0.upto(ss.length - 1) do |something|
    element = ss[lines]
    if( element.typename != "Edge")
      others += 1
    end
    lines += 1
  end
 
  lines = 0
 #//////////  ループ開始  //////////
  0.upto(ss.length - 1) do |something|
    if( ss[lines].typename == "Edge" )
    
      #//////////  初期設定  //////////
      i=0
      j=0
      x=0
      y=0
      z=0
      pts = ss[lines].vertices
      v1 = pts[0].position
      v2 = pts[1].position
      lngth=((v1.x-v2.x)**2+(v1.y-v2.y)**2)**0.5
      radn=Math.atan2(v2.y-v1.y , v2.x-v1.x)
      entities=model.active_entities
      group=entities.add_group
      entities=group.entities  
      #//////////  隅柱  //////////
      if ($ksumiW*$ksumiD>0)
        j=0
        x0=Math.cos(radn)*$ksumiW / 2
        y0=Math.sin(radn)*$ksumiW / 2
        #一本目
        pt=[];i=0
        x=v1.x-x0
        y=v1.y-y0
        z=v1.z
          pt[i]=[x,y,z];i+=1
        x=v1.x+x0
        y=v1.y+y0
          pt[i]=[x,y,z];i+=1
        z=v1.z+$k1taka-$k1H
          pt[i]=[x,y,z];i+=1
        x=v1.x-x0
        y=v1.y-y0
          pt[i]=[x,y,z]
        face=entities.add_face pt
        face.pushpull $ksumiD/2
        face.pushpull $ksumiD/2
        #二本目
        pt=[];i=0
        x=v2.x-x0
        y=v2.y-y0
        z=v2.z
          pt[i]=[x,y,z];i+=1
        x=v2.x+x0
        y=v2.y+y0
          pt[i]=[x,y,z];i+=1
        z=v2.z+$k1taka-$k1H
          pt[i]=[x,y,z];i+=1
        x=v2.x-x0
        y=v2.y-y0
          pt[i]=[x,y,z]
        face=entities.add_face pt
        face.pushpull $ksumiD/2
        face.pushpull $ksumiD/2
      end
      #//////////  間柱  //////////
      if ($ksumiW*$ksumiD>0)
        nums=(lngth / $knakaP).to_i+1
        pitch=lngth / nums
        x0=Math.cos(radn)*$knakaW / 2
        y0=Math.sin(radn)*$knakaW / 2
        x1=Math.cos(radn)*pitch
        y1=Math.sin(radn)*pitch
        z1=(v2.z-v1.z)/nums
        j=1
        while j<nums
          pt=[];i=0
          x=v1.x+x1*j+x0
          y=v1.y+y1*j+y0
          z=v1.z+z1*j
            pt[i]=[x,y,z];i+=1
          x=v1.x+x1*j-x0
          y=v1.y+y1*j-y0
            pt[i]=[x,y,z];i+=1
          z=v1.z+z1*j+$k1taka-$k1H
            pt[i]=[x,y,z];i+=1
          x=v1.x+x1*j+x0
          y=v1.y+y1*j+y0
            pt[i]=[x,y,z]
          face=entities.add_face pt
          face.pushpull $knakaD/2
          face.pushpull $knakaD/2
          j=j+1
        end
      end
      
      #//////////  手摺  //////////
      if ($k1W*$k1H>0)
        pt=[];i=0;j=0
        x0=Math.cos(radn)*$ksumiW / 2
        y0=Math.sin(radn)*$ksumiW / 2
        x=v1.x-x0
        y=v1.y-y0
        z=$k1taka+v1.z
          pt[i]=[x,y,z];i+=1
        x=v2.x+x0
        y=v2.y+y0
        z=$k1taka+v2.z
          pt[i]=[x,y,z];i+=1
        z=$k1taka+v2.z-$k1H
          pt[i]=[x,y,z];i+=1
        x=v1.x-x0
        y=v1.y-y0
        z=$k1taka+v1.z-$k1H
          pt[i]=[x,y,z]
        face=entities.add_face pt
        face.pushpull $k1W/2
        face.pushpull $k1W/2
      end
      #//////////  上子  //////////
      if ($k2W*$k2H>0)
        pt=[];i=0;j=0
        x=v1.x
        y=v1.y
        z=$k1taka-$k2taka+v1.z
          pt[i]=[x,y,z];i+=1
        x=v2.x
        y=v2.y
        z=$k1taka-$k2taka+v2.z
          pt[i]=[x,y,z];i+=1
        z=$k1taka-$k2taka+v2.z-$k2H
          pt[i]=[x,y,z];i+=1
        x=v1.x
        y=v1.y
        z=$k1taka-$k2taka+v1.z-$k2H
          pt[i]=[x,y,z]
        face=entities.add_face pt
        face.pushpull $k2W/2
        face.pushpull $k2W/2
      end
      #//////////  下子  //////////
      if ($k3W*$k3H>0)
        pt=[];i=0;j=0
        x=v1.x
        y=v1.y
        z=$k3taka+v1.z
          pt[i]=[x,y,z];i+=1
        x=v2.x
        y=v2.y
        z=$k3taka+v2.z
          pt[i]=[x,y,z];i+=1
        z=$k3taka+v2.z-$k3H
          pt[i]=[x,y,z];i+=1
        x=v1.x
        y=v1.y
        z=$k3taka+v1.z-$k3H
          pt[i]=[x,y,z]
        face=entities.add_face pt
        face.pushpull $k3W/2
        face.pushpull $k3W/2
      end
      #//////////  横桟  //////////
      if (@ksan=="border")
        #手摺下端の高さ
        kz1=$k1taka-$k1H
        if ($k2taka>0)
          #上胴縁芯の高さ
          kz1=$k1taka-$k2taka-$k2H/2
        end
        #下胴縁の芯までの高さ
        kz2=$k3taka-$k3H/2
        kzP=(kz1-kz2)/(((kz1-kz2)/$ksanP).to_i)
        j=1
        while j<((kz1-kz2)/$ksanP).to_i
          pt=[];i=0
          x=v1.x
          y=v1.y
          z=v1.z+kz2+kzP*j+$ksanH/2
            pt[i]=[x,y,z];i+=1
          x=v2.x
          y=v2.y
          z=v2.z+kz2+kzP*j+$ksanH/2
            pt[i]=[x,y,z];i+=1
          z=v2.z+kz2+kzP*j-$ksanH/2
            pt[i]=[x,y,z];i+=1
          x=v1.x
          y=v1.y
          z=v1.z+kz2+kzP*j-$ksanH/2
            pt[i]=[x,y,z]
          face=entities.add_face pt
          face.pushpull $ksanD/2
          face.pushpull $ksanD/2
          j=j+1
        end
      end
      #//////////  縦桟  //////////
      if (@ksan=="stripe")
        #手摺下端高さ
        kz1=$k1taka-$k1H
        if ($k2taka>0)
          #上胴縁下端高さ
          kz1=$k1taka-$k2taka-$k2H
        end
        #下胴縁天端高さ
        kz2=$k3taka
        nums=(lngth / $ksanP).to_i+1
        pitch=lngth / nums
        x0=Math.cos(radn)*$ksanH / 2
        y0=Math.sin(radn)*$ksanH / 2
        x1=Math.cos(radn)*pitch
        y1=Math.sin(radn)*pitch
        z1=(v2.z-v1.z)/nums
        j=1
        while j<nums
          pt=[];i=0
          x=v1.x+x1*j+x0
          y=v1.y+y1*j+y0
          z=v1.z+z1*j+kz1
            pt[i]=[x,y,z];i+=1
          x=v1.x+x1*j-x0
          y=v1.y+y1*j-y0
            pt[i]=[x,y,z];i+=1
          z=v1.z+z1*j+kz2
            pt[i]=[x,y,z];i+=1
          x=v1.x+x1*j+x0
          y=v1.y+y1*j+y0
            pt[i]=[x,y,z]
          face=entities.add_face pt
          face.pushpull $ksanD/2
          face.pushpull $ksanD/2
          j=j+1
        end
      end
      
      #//////////  パネル  //////////
      if (@ksan=="panel")
        kz1=$k1taka-$k1H
        if ($k2taka>0)
          kz1=$k1taka-$k2taka-$k2H
        end
        kz2=$k3taka
        pt=[];i=0
        x=v1.x
        y=v1.y
        z=v1.z+kz1
          pt[i]=[x,y,z];i+=1
        z=v1.z+kz2
          pt[i]=[x,y,z];i+=1
        x=v2.x
        y=v2.y
        z=v2.z+kz2
          pt[i]=[x,y,z];i+=1
        z=v2.z+kz1
          pt[i]=[x,y,z]
        face=entities.add_face pt
      end
      
      #//////////  縦交差  //////////
      if (@ksan=="cross")
        #水平
        kz1=$k1taka-$k1H
        kz1=$k1taka-$k2taka-$k2H / 2 if $k2taka>0
        kz2=$k3taka-$k3H/2
        j=1
        while j<((kz1-kz2)/$ksanH).to_i
          pt=[];i=0
          x=v1.x
          y=v1.y
          z=v1.z+kz2+(kz1-kz2)/(((kz1-kz2)/$ksanH).to_i)*j
            pt[i]=[x,y,z];i+=1
          x=v2.x
          y=v2.y
          z=v2.z+kz2+(kz1-kz2)/(((kz1-kz2)/$ksanH).to_i)*j
            pt[i]=[x,y,z]
          face=entities.add_line pt
          j=j+1
        end
        #垂直
        kz1=$k1taka-$k1H
        kz1=$k1taka-$k2taka-$k2H if $k2taka>0
        kz2=$k3taka
        j=1
        num=(lngth / $ksanP).to_i+1
        x0=(v2.x-v1.x) / num
        y0=(v2.y-v1.y) / num
        z0=(v2.z-v1.z) / num
        while j<num
          pt=[];i=0
          x=v1.x+x0*j
          y=v1.y+y0*j
          z=v1.z+kz1+z0*j
            pt[i]=[x,y,z];i+=1
          z=v1.z+kz2+z0*j
            pt[i]=[x,y,z]
          face=entities.add_line pt
          j=j+1
        end
      end
      
      #//////////  メッシュ  //////////
      if (@ksan=="mesh")
        kz1=$k1taka-$k1H							#基点1の高さ取得
        kz1=$k1taka-$k2taka-$k2H if $k2taka>0		
        kz2=$k3taka
        h=kz1-kz2									#h:高低差を出しておく
        ratio=$ksanH/ $ksanP						#ratio:メッシュの縦横比を算出
        num=(lngth / $ksanP + h/ $ksanH).to_i+1		#num:書く本数の総数を算出
        num2=(lngth / $ksanP).to_i+1				#num2:フェンス長さ分の本数を算出
        num3=(h/ $ksanH).to_i+1						#num3:端部で垂直に書く本数の総数を算出
        ratio=(h/num3)/(lngth/num2)
        x0=(v2.x-v1.x) / num2						#各座標系に加算する差分
        y0=(v2.y-v1.y) / num2
        z0=(v2.z-v1.z) / num2
        j=0
        flag=j
        while j<num									#j:上で求めた総数回分繰り返すループ
          j=j+1
          pt=[];pt2=[];i=0
          #上端
          x=v1.x+x0*j								#上端座標はひたすらプラス
          y=v1.y+y0*j								#絶対座標値で明確に算定
          z=v1.z+z0*j+kz1							#そのため下端座標値も変数名は同じ
          x2=v2.x-x0*j
          y2=v2.y-y0*j
          z2=v2.z-z0*j+kz1
          lngth2=((x0*j)**2+(y0*j)**2)**0.5
          if num2<j									#上端がフェンス端を越えた場合
            #UI.messagebox("!")
            x=v2.x									#x,yはデッドエンド
            y=v2.y
            z=v2.z+kz1-(lngth2-lngth)*ratio			#z座標が下降する
            x2=v1.x
            y2=v1.y
            z2=v1.z+kz1-(lngth2-lngth)*ratio
          end
            pt[i]=[x,y,z]
            pt2[i]=[x2,y2,z2];i+=1
          #下端
          x=v1.x+x0*(j-num3)
          y=v1.y+y0*(j-num3)
          z=v1.z+z0*(j-num3)+kz2
          x2=v2.x-x0*(j-num3)
          y2=v2.y-y0*(j-num3)
          z2=v2.z-z0*(j-num3)+kz2
          if lngth2 < h / ratio #下端がフェンス端以下の場合
            x=v1.x
            y=v1.y
            z=v1.z+kz1-lngth2*ratio
            x2=v2.x
            y2=v2.y
            z2=v2.z+kz1-lngth2*ratio
            flag=j
          end
          pt[i]=[x,y,z]
          pt2[i]=[x2,y2,z2]
          face=entities.add_line pt
          face=entities.add_line pt2
        end
      end
      #//////////  ここまで  //////////
      status = ss[lines].hidden = true
    end
    #次の線
    lines = lines + 1
  end
end

def gen_yokoyamato
  model = Sketchup.active_model
  model.start_operation "Extrude lines"
  entities = model.active_entities
  ss = model.selection
  
  if ss.empty? 
    UI.messagebox("请选择线。")
    return nil
  end
  
  #線要素だけ拾い出し
  others = 0
  i = 0
  
  0.upto(ss.length - 1) do |something|
    element = ss[i]
    if( element.typename != "Edge")
      others = others + 1
    end
    i = i + 1
  end
  
  #デフォルト設定
  $height = 1800.mm if not $height
  $atsu = 27.mm if not $atsu
  $sei = 150.mm if not $sei
  $kei = 60.mm if not $kei
  $pitch = 2000.mm if not $pitch
  $clrR = 65 if not $clrR
  $clrG = 60 if not $clrG
  $clrB = 50 if not $clrB
  #ダイアログ
  prompts = ["围墙高度","板厚","板高","间柱尺寸","间柱间距","红(0-255)","緑(0-255)","蓝(0-255)"]
  values = [$height,$atsu,$sei,$kei,$pitch,$clrR,$clrG,$clrB]
  results = inputbox prompts, values, "栅栏围墙"
  return if not results
  $height,
  $atsu,
  $sei,
  $kei,
  $pitch,
  $clrR,
  $clrG,
  $clrB = results
  clr1= Sketchup::Color.new($clrR , $clrG , $clrB )
  i = 0
  0.upto(ss.length - 1) do |something|
    if( ss[i].typename == "Edge" )
      #天板
      entities=model.active_entities
      group=entities.add_group
      entities=group.entities
      pts = ss[i].vertices
      v1 = pts[0].position
      v2 = pts[1].position
      pt=[]
      pt[0] = [v1.x, v1.y, v1.z + $height]
      pt[1] = [v1.x, v1.y, v1.z + $height-$atsu]
      pt[2] = [v2.x, v2.y, v2.z + $height-$atsu]
      pt[3] = [v2.x, v2.y, v2.z + $height]
      face=entities.add_face pt
      face.material = clr1
      tennita=$kei / 2 + $atsu + 10.mm
      face.pushpull tennita
      face.pushpull tennita
      
      #横板
      nums=(($height-$atsu) / $sei).to_i
      j=0
      while j<nums
        entities=model.active_entities
        group=entities.add_group
        entities=group.entities
        pt=[]
        pt[0] = [v1.x, v1.y, v1.z + $height-$sei*j-$atsu]
        pt[1] = [v1.x, v1.y, v1.z + $height-$sei*(j+1)-$atsu]
        pt[2] = [v2.x, v2.y, v2.z + $height-$sei*(j+1)-$atsu]
        pt[3] = [v2.x, v2.y, v2.z + $height-$sei*j-$atsu]
        face=entities.add_face pt
        face.material =  clr1
        ppd1=$kei / 2 + $atsu
        ppd2=-$kei / 2
        ppd1=$kei / 2 + $atsu  if j % 2 ==1
        ppd2=-$kei / 2 if j % 2 ==1
        face.reverse! if j % 2 ==1
        face.pushpull ppd1
        face.pushpull ppd2    
        j+=1
      end
      #支柱
      lngth=((v1.x-v2.x)**2+(v1.y-v2.y)**2)**0.5
      radn=Math.atan2(v2.y-v1.y , v2.x-v1.x)
      nums=(lngth / $pitch).to_i+1
      pitch2=lngth / nums
      x0=Math.cos(radn)*$kei / 2
      y0=Math.sin(radn)*$kei / 2
      xp=(v2.x-v1.x) / nums
      yp=(v2.y-v1.y) / nums
      if pitch2>1
        j=0
        while j<=nums
          entities=model.active_entities
          group=entities.add_group
          entities=group.entities
          pt=[]
          
          pt[0] = [v1.x + x0 + xp*j, v1.y + y0 + yp*j, v1.z]
          pt[1] = [v1.x - x0 + xp*j, v1.y - y0 + yp*j, v1.z]
          pt[2] = [v1.x - x0 + xp*j, v1.y - y0 + yp*j, v1.z + $height - $atsu]
          pt[3] = [v1.x + x0 + xp*j, v1.y + y0 + yp*j, v1.z + $height - $atsu]
          face=entities.add_face pt
          face.material =  clr1
          face.pushpull $kei/2   
          face.pushpull $kei/2   
          j+=1
        end
      end
    end
    #次の線
    i = i + 1
  end
  model.commit_operation
end

def stair1
	#初期設定
	i=0
	j=0
	x=0
	y=0
	z=0
	pai=3.141592653
	$rkaidaka=2900.mm if not $rkaidaka
	$rhaba=900.mm if not $rhaba
	$rcolumn=125.mm if not $rcolumn
	$rkaku=360 if not $rkaku
	$rdansu=15 if not $rdansu
	$ratsu=40.mm if not $ratsu
	$rtesuriH=1100.mm if not $rtesuriH
	$rtesuriP=200.mm if not $rtesuriP
	$rtesuriN=3 if not $rtesuriN
	$rgrip1=20.mm if not $rgrip1
	$rgrip2=5.mm if not $rgrip2
	$rketaH=0.mm if not $rketaH
	$rketaD=12.mm if not $rketaD
	$rukeH=0.mm if not $rukeH
	$rukeD=12.mm if not $rukeD
	$tesurikoP=2 if not $tesurikoP
	$tesurikoK=6.mm if not $tesurikoK
	$tesurikoN=1 if not $tesurikoN
	$group=2 if not $block
	# ダイアログ
	prompts=[
		"楼梯高度",
		"踏步净宽",
		"中柱半径",
		"旋转角度",
		"踏步数量",
		"踏步数量",
		"扶手高度",
		"横档间距",
		"横档数量",
		"扶手半径",
		"横档半径",
		"侧挡板高度",
		"侧挡板厚度",
		"踏步梁高度",
		"踏步梁厚度",
		"栏杆间距(踏步段数为単位)",
		"栏杆半径",
		"起始踏步",
		"是否成组(0:不成组1:全部成组2:每个部件成组)"
	]
	values=[
		$rkaidaka,
		$rhaba,
		$rcolumn,
		$rkaku,
		$rdansu,
		$ratsu,
		$rtesuriH,
		$rtesuriP,
		$rtesuriN,
		$rgrip1,
		$rgrip2,
		$rketaH,
		$rketaD,
		$rukeH,
		$rukeD,
		$tesurikoP,
		$tesurikoK,
		$tesurikoN,
		$group
	]
	results=inputbox prompts, values, "旋转楼梯"
	
	return if not results
		$rkaidaka,
		$rhaba,
		$rcolumn,
		$rkaku,
		$rdansu,
		$ratsu,
		$rtesuriH,
		$rtesuriP,
		$rtesuriN,
		$rgrip1,
		$rgrip2,
		$rketaH,
		$rketaD,
		$rukeH,
		$rukeD,
		$tesurikoP,
		$tesurikoK,
		$tesurikoN,
		$group	=results
	
	rkeage=$rkaidaka / $rdansu
	rdankaku=($rkaku / ($rdansu-1))*pai/180
	model=Sketchup.active_model
		entities=model.active_entities
	if $group==1
    	group=entities.add_group
    	entities=group.entities
    end
#//////////  支柱  //////////
	i=0
	x=0
	y=0
	z=0
	circl=[]
	face=[]
		pt=[x, y, z]
	
	if $group==2
		entities=model.active_entities
    	group=entities.add_group
    	entities=group.entities
    end
	
	circl=entities.add_circle pt, Z_AXIS, $rcolumn, 24
	face=entities.add_face circl
	face.pushpull -$rkaidaka
#//////////  各段  //////////
	j=0
	rkei=$rcolumn+$rhaba
	while j<$rdansu
		#踏板
		i=0;x=0;y=0;pt=[]
		rkijunkaku=rdankaku*j
		j=j+1
		z=rkeage*j
			pt[i]=[x,y,z];i=i+1#中心点
		
		if $group==2
			entities=model.active_entities
			group=entities.add_group
    		entities=group.entities
    	end
		
		while i<6
			x=rkei*Math.cos(rkijunkaku+rdankaku*(i-1)/4)
			y=rkei*Math.sin(rkijunkaku+rdankaku*(i-1)/4)
				pt[i]=[x,y,z];i=i+1
		end
		face=entities.add_face pt
		face.pushpull -$ratsu
		
		if $rukeH*$rukeD>0
		#受け金物
			i=0;pt=[]
			ukerad=rkijunkaku+rdankaku/2
			sentan=rkei-100.mm
			sentansei=$rukeH
			nemotosei=(sentan-$rcolumn)/20
			x=sentan*Math.cos(ukerad)
			y=sentan*Math.sin(ukerad)
			z=z-$ratsu
				pt[i]=[x,y,z];i=i+1
			z=z-sentansei
				pt[i]=[x,y,z];i=i+1
			x=$rcolumn*Math.cos(ukerad)
			y=$rcolumn*Math.sin(ukerad)
			z=z-nemotosei
				pt[i]=[x,y,z];i=i+1
			z=z+sentansei+nemotosei
				pt[i]=[x,y,z];i=i+1
			face=entities.add_face pt
			face.pushpull $rukeD
		end
		
		#手摺子
		if $tesurikoP*$tesurikoK>0
			if (j-$tesurikoN)%$tesurikoP == 0
				if $group == 2
					entities=model.active_entities
    				group=entities.add_group
    				entities=group.entities
    			end
				i=0;pt=[]
				$tesuriko_rad=rkijunkaku+rdankaku/2
				hanasaki=rkei+$tesurikoK
				hanasaki += $rketaD if $rketaD*$rketaH != 0
				x=hanasaki*Math.cos($tesuriko_rad)
				y=hanasaki*Math.sin($tesuriko_rad)
				z=rkeage*j-$ratsu
				circl=entities.add_circle [x,y,z], Z_AXIS, $tesurikoK, 10
				face=entities.add_face circl
				face.pushpull $rtesuriH+$ratsu+rkeage/2
			end
		end
	end
#//////////  手摺  //////////
	p=0
	while p<=$rtesuriN
		pt=[];i=0
		j=0
		rtbunkatu=6*pai/180
		rzenkaku=rdankaku*$rdansu
		zz=$rkaidaka/(rzenkaku/rtbunkatu)
		#立ち下がり
		rkei=$rcolumn+$rhaba+$rgrip1
		rkei=$rcolumn+$rhaba+$rgrip2 if p>0
		rkei+=$rketaD if $rketaD*$rketaH>0
		x=rkei
		y=0
		z=rkeage+$rtesuriH-$rtesuriP*p-50.mm
			pt[i]=[x,y,z];i=i+1
		#螺旋
		z=rkeage+$rtesuriH-$rtesuriP*p
		while j<=rzenkaku
			x=rkei*Math.cos(j)
			y=rkei*Math.sin(j)
				pt[i]=[x,y,z];i=i+1
			z=z+zz
			j=j+rtbunkatu
		end
		#手摺断面をfollowme
		
		if $group==2
			entities=model.active_entities
    		group=entities.add_group
    		entities=group.entities
    	end
		
		railline=entities.add_edges pt
		x=rkei
		y=0
		z=rkeage+$rtesuriH-$rtesuriP*p-50.mm
			pth=[x, y, z]
		$rgrip=$rgrip1
		$rgrip=$rgrip2 if p!=0
		circl=entities.add_circle pth, Z_AXIS, $rgrip, 10
		face=entities.add_face circl
		face.reverse!
		face.followme railline
		p=p+1
	end
	
#//////////  側桁  //////////
	if ($rketaH*$rketaD>0)
		j=0
		rkei=$rcolumn+$rhaba+$rketaD
		rkei2=$rcolumn+$rhaba
		rsasara=$rketaH/Math.cos(*Math.atan(rkeage/rkei*rdankaku))
		#螺旋
		z=rkeage/2-$ratsu/2
		
		if $group==2
			entities=model.active_entities
			group=entities.add_group
			entities=group.entities
		end
		
		while j<=rzenkaku
			#外側
			pt=[];i=0
			x1=rkei*Math.cos(j)
			y1=rkei*Math.sin(j)
			z1=z+rsasara/2
				pt[i]=[x1,y1,z1];i=i+1
			z2=z1-rsasara
				pt[i]=[x1,y1,z2];i=i+1
			x2=rkei*Math.cos(j+rtbunkatu)
			y2=rkei*Math.sin(j+rtbunkatu)
			z3=z2+zz
				pt[i]=[x2,y2,z3];i=i+1
			z4=z3+rsasara
				pt[i]=[x2,y2,z4]
			entities.add_face pt
			#内側
			pt=[];i=0
			x3=rkei2*Math.cos(j)
			y3=rkei2*Math.sin(j)
				pt[i]=[x3,y3,z1];i=i+1
				pt[i]=[x3,y3,z2];i=i+1
			x4=rkei2*Math.cos(j+rtbunkatu)
			y4=rkei2*Math.sin(j+rtbunkatu)
				pt[i]=[x4,y4,z3];i=i+1
				pt[i]=[x4,y4,z4]
			face=entities.add_face pt
			#上面
			pt=[];i=0
				pt[i]=[x1,y1,z1];i=i+1
				pt[i]=[x3,y3,z1];i=i+1
				pt[i]=[x2,y2,z4];i=i+1
			face=entities.add_face pt
			pt=[];i=0
				pt[i]=[x3,y3,z1];i=i+1
				pt[i]=[x2,y2,z4];i=i+1
				pt[i]=[x4,y4,z4];i=i+1
			face=entities.add_face pt
			#下面
			pt=[];i=0
				pt[i]=[x1,y1,z2];i=i+1
				pt[i]=[x3,y3,z2];i=i+1
				pt[i]=[x2,y2,z3];i=i+1
			face=entities.add_face pt
			pt=[];i=0
				pt[i]=[x3,y3,z2];i=i+1
				pt[i]=[x2,y2,z3];i=i+1
				pt[i]=[x4,y4,z3];i=i+1
			face=entities.add_face pt
			z=z+zz
			j=j+rtbunkatu
		end
	end
end

def stair2
	#初期設定
	i=0
	j=0
	x=0
	y=0
	z=0
	$kaidaka=2900.mm if not $kaidaka
	$haba=900.mm if not $haba
	$dansu=16 if not $dansu
	$dan1=8 if not $dan1
	$humitura=250.mm if not $humitura
	$hana=30.mm if not $hana
	$atsu=180.mm if not $atsu
	$nige=50.mm if not $nige
	$kabe=0.mm if not $kabe
	$hari=450.mm if not $hari
	$tesuriD=0.mm if not $tesuriD
	$tesuriH=0.mm if not $tesuriH
	$naka_tesuri=0  if not $naka_tesuri
	$kane_tesuri_Height=0.mm if not $kane_tesuri_Height
	$kane_tesuriD=40.mm if not $kane_tesuriD
	$kane_tesuriH=25.mm if not $kane_tesuriH
	$nakagoP=100.mm if not $nakagoP
	$nakagoN=2 if not $nakagoN
	$nakagoD=25.mm if not $nakagoD
	$nakagoH=10.mm if not $nakagoH
	$group=2 if not $group
	
	# ダイアログ
	prompts=[
		"楼梯高度",
		"梯段净宽",
		"踏步总数",
		"一跑步数",
		"踏步宽度",
		"踢步缩进 ",
		"平台板厚",
		"隔墙平台交叉",
		"隔墙厚度",
		"平台梁",
		"侧墙墙厚",
		"侧墙墙高",
		"隔墙扶手(0:无1:有)",
		"侧墙扶手高度",
		"是否成组(0:不成组1:全部成组2:每个部件成组)"
	]
	values=[
		$kaidaka,
		$haba,
		$dansu,
		$dan1,
		$humitura,
		$hana,
		$atsu,
		$nige,
		$kabe,
		$hari,
		$tesuriD,
		$tesuriH,
		$naka_tesuri,
		$kane_tesuri_Height,
		$group
	]
	results=inputbox prompts, values, "悬臂楼梯"
	
	return if not results
		$kaidaka,
		$haba,
		$dansu,
		$dan1,
		$humitura,
		$hana,
		$atsu,
		$nige,
		$kabe,
		$hari,
		$tesuriD,
		$tesuriH,
		$naka_tesuri,
		$kane_tesuri_Height,
		$group = results
	
	if $kane_tesuri_Height > 0
	
	prompts=[
		"扶手截面宽度",
		"扶手截面高度",
		"横档间距",
		"横档数量",
		"横档截面宽度",
		"横档截面高度", 
	]
	values=[
		$kane_tesuriD,
		$kane_tesuriH,
		$nakagoP,
		$nakagoN,
		$nakagoD,
		$nakagoH,
	]
	results=inputbox prompts, values, "扶手参数"
	
	return if not results
		$kane_tesuriD,
		$kane_tesuriH,
		$nakagoP,
		$nakagoN,
		$nakagoD,
		$nakagoH = results
	
	end
	
	$keage=$kaidaka / $dansu
	$humimen=$humitura+$hana
	$dan2=$dansu-$dan1
	model=Sketchup.active_model
	
	if $group>0
		entities=model.active_entities
		group=entities.add_group
		entities=group.entities
	end
	
		pt=[]
#//////////下段
	#一段目
	x=$tesuriD
		pt[i]=[x,y,z];i=i+1
	y=$haba+$hana+$nige
		pt[i]=[x,y,z];i=i+1
	#各段
	while j < $dan1
		j=j+1
		y=y-$hana
		z=z+$keage
			pt[i]=[x,y,z];i=i+1
		y=y+$humimen
		if ( j == $dan1 )
			y=y-$humimen+$haba+$nige
		end
			pt[i]=[x,y,z];i=i+1
	end
	
	z=z-$atsu
		pt[i]=[x,y,z];i=i+1	#水平部
	y=y-$haba-$nige+$humitura
		pt[i]=[x,y,z];i=i+1	#揚げ裏
	y=y-$humitura*$dan1
	z=z-$keage*$dan1 
		pt[i]=[x,y,z];i=i+1
	y=y-$haba-$nige
		pt[i]=[x,y,z];i=i+1	#水平部
	z=z+$atsu
		pt[i]=[x,y,z];i=i+1
	face=entities.add_face pt
	face.pushpull -$haba
	
	#//////////上段
	if ($dansu > $dan1)
		
		if $group==2
			entities=model.active_entities
			group=entities.add_group
			entities=group.entities
		end
		
		pt=[];i=0
		j=0
		#一段目
		x=$tesuriD+$haba+$kabe
		y=$haba *2+$nige*2+$humitura*($dan1-1)
		z=$keage*$dan1
			pt[i]=[x,y,z];i=i+1
		y=y-$haba-$nige-$hana
			pt[i]=[x,y,z];i=i+1
		#各段
		while j < $dan2
			j=j+1
			y=y+$hana
			z=z+$keage
				pt[i]=[x,y,z];i=i+1
			y=y-$humimen
			if ( j == $dan2 )
				y=y+$humimen-$haba-$nige
			end
				pt[i]=[x,y,z];i=i+1
		end
		#水平部
		z=z-$atsu
			pt[i]=[x,y,z];i=i+1
		y=y+$haba+$nige-$humitura
			pt[i]=[x,y,z];i=i+1
		#揚げ裏
		y=y+$humitura*$dan2
		z=z-$keage*$dan2
			pt[i]=[x,y,z];i=i+1
		#水平部
		y=y+$haba+$nige
			pt[i]=[x,y,z];i=i+1
		z=z+$atsu
			pt[i]=[x,y,z]
		face=entities.add_face pt
		face.pushpull $haba
	end
	
	#//////////中壁//////////
	if ($kabe>0)
		
		if $group==2
			entities=model.active_entities
			group=entities.add_group
			entities=group.entities
		end
		
			pt=[];i=0
		x=$tesuriD+$haba
		y=$haba
		z=0
			pt[i]=[x,y,z];i=i+1
		x=x+$kabe
			pt[i]=[x,y,z];i=i+1
		y=y+$humitura*($dan1 -1)+($nige *2) 
			pt[i]=[x,y,z];i=i+1
		x=x-$kabe
			pt[i]=[x,y,z]
		face=entities.add_face pt
		face.pushpull -$kaidaka
		
	#//////////中間踊場
		if ($dansu > $dan1)
			
			if $group==2
				entities=model.active_entities
				group=entities.add_group
				entities=group.entities
			end
			
			i=0
				pt=[]
			x=$tesuriD+$haba
			y=$haba+$humitura*($dan1-1)+$nige*2
			z=$keage*$dan1
				pt[i]=[x,y,z];i=i+1
			z=z-$hari
				pt[i]=[x,y,z];i=i+1
			x=x+$kabe
				pt[i]=[x,y,z];i=i+1
			z=z+$hari
				pt[i]=[x,y,z]
			face=entities.add_face pt
			face.pushpull -$haba
			
			#//////////廊下側梁//////////
			pt=[];i=0
			x=$tesuriD+$haba
			y=$haba
			z=$kaidaka
				pt[i]=[x,y,z];i=i+1
			x=x+$kabe
				pt[i]=[x,y,z];i=i+1
			z=z-$hari
				pt[i]=[x,y,z];i=i+1
			x=x-$kabe
				pt[i]=[x,y,z];i=i+1
			face=entities.add_face pt
			face.pushpull -$haba
		end
	end
	
	#//////////下段手摺
	if $tesuriD*$tesuriH != 0
		
		if $group==2
			entities=model.active_entities
			group=entities.add_group
			entities=group.entities
		end
		
		pt=[];i=0
		x=0
		y= $tesuriD
		z=-$atsu
			pt[i]=[x,y,z];i=i+1			#最下点
		y=$haba+$nige
			pt[i]=[x,y,z];i=i+1			#キックアップ基点
		y=y+$humitura*$dan1
		z=z+$keage*$dan1 
			pt[i]=[x,y,z];i=i+1			#終点
		y=y+$haba+$nige+$tesuriD-$humitura
			pt[i]=[x,y,z];i=i+1			#水平端部
		z=z+$atsu+$tesuriH
			pt[i]=[x,y,z];i=i+1			#手摺立ち上がり
		y=y-$haba-$nige-$tesuriD
			pt[i]=[x,y,z];i=i+1			#キックダウン基点
		y=y-$humitura*$dan1
		z=z-$keage*$dan1 
			pt[i]=[x,y,z];i=i+1			#終点
		y=y -$haba-$nige+$humitura+$tesuriD
			pt[i]=[x,y,z];i=i+1			#基点上部
		face=entities.add_face pt
		face.pushpull $tesuriD
		
		#//////////手摺踊場
		if ($dansu > $dan1)
			
			if $group==2
				entities=model.active_entities
				group=entities.add_group
				entities=group.entities
			end
			
				pt=[];i=0
			x= $tesuriD
			y= $humitura*($dan1-1 )+$haba*2+$nige*2
			z=$keage*$dan1 -$atsu
				pt[i]=[x,y,z];i=i+1
			x=x+$haba*2+$kabe
				pt[i]=[x,y,z];i=i+1
			y=y+$tesuriD
				pt[i]=[x,y,z];i=i+1
			x=x-$haba*2-$kabe
				pt[i]=[x,y,z]
			face=entities.add_face pt
			face.pushpull $atsu+$tesuriH
			
			#//////////手摺上段
			
			if $group==2
				entities=model.active_entities
				group=entities.add_group
				entities=group.entities
			end
			
			pt=[];i=0
			x=$tesuriD+$haba*2+$kabe
			y=$haba *2+$nige*2+$humitura*($dan1-1)+$tesuriD
			z=$keage*$dan1 -$atsu
				pt[i]=[x,y,z];i=i+1#最下点
			y=y-$haba-$nige-$tesuriD
				pt[i]=[x,y,z];i=i+1#キックアップ基点
			y=y-$humitura*$dan2
			z=z+$keage*$dan2
				pt[i]=[x,y,z];i=i+1#終点
			y=y-$haba-$nige+$humitura+$tesuriD
				pt[i]=[x,y,z];i=i+1#水平端部
			z=z+$atsu+$tesuriH
				pt[i]=[x,y,z];i=i+1#手摺立ち上がり
			y=y+$haba+$nige-$tesuriD
				pt[i]=[x,y,z];i=i+1#キックダウン基点
			y=y+$humitura*$dan2
			z=z-$keage*$dan2
				pt[i]=[x,y,z];i=i+1#終点
			y=y+$haba+$nige-$humitura+$tesuriD
				pt[i]=[x,y,z]#基点上部
			face=entities.add_face pt
			face.pushpull -$tesuriD
		end	
	end
	#中壁手摺
	if $naka_tesuri==1
		
		if $group==2
			entities=model.active_entities
			group=entities.add_group
			entities=group.entities
		end
		
		pt=[];i=0;aki=50.mm
		x=$tesuriD+$haba-aki
		y=$haba+$nige
		z=$keage+750.mm
			pt[i]=[x,y,z];i=i+1			#最下点
		circl=entities.add_circle [x,y,z], Z_AXIS, 19.mm, 10
		face=entities.add_face circl
		z+=50.mm
			pt[i]=[x,y,z];i=i+1
		y+=$humitura*($dan1-1)
		z+=$keage*($dan1-1)
			pt[i]=[x,y,z];i=i+1
		y+=$nige
			pt[i]=[x,y,z];i=i+1
		if $dan2>0
			y+=aki
				pt[i]=[x,y,z];i=i+1
			x+=aki*2+$kabe
				pt[i]=[x,y,z];i=i+1
			y-=$nige+aki
				pt[i]=[x,y,z];i=i+1
			y-=$humitura*($dan2-1)
			z+=$keage*($dan2-1)
				pt[i]=[x,y,z];i=i+1
			y-=$nige
				pt[i]=[x,y,z];i=i+1
		end
		railline=entities.add_edges pt
		face.reverse!
		face.followme railline
		
	end
	#金物手摺
	if $kane_tesuri_Height>0
		p=0
		while p<=$nakagoN
			
			if $group==2
				entities=model.active_entities
				group=entities.add_group
				entities=group.entities
			end
			
			pt=[];i=0
			space=$tesuriD
			space=$kane_tesuriD*2 if $tesuriD*$tesuriH==0
			x=space/2
			y=space
			z=$tesuriH+$kane_tesuri_Height-$nakagoP*p
				pt[i]=[x,y,z];i=i+1
			y+=$haba-$humitura+$nige-space
				pt[i]=[x,y,z];i=i+1
			y+=$humitura*$dan1
			z+=$keage*$dan1
				pt[i]=[x,y,z];i=i+1
			y+=$haba+$nige+space/2
				pt[i]=[x,y,z];i=i+1
			if $dan2>0
				x+=$haba*2+$kabe+space
					pt[i]=[x,y,z];i=i+1
				y-=$haba-$humitura+$nige+space/2
					pt[i]=[x,y,z];i=i+1
				y-=$humitura*$dan2
				z+=$keage*$dan2
					pt[i]=[x,y,z];i=i+1
				y-=$haba-space+$nige
					pt[i]=[x,y,z]
			end
			railline=entities.add_edges pt
			w=$kane_tesuriD
			h=$kane_tesuriH
			w=$nakagoD if p>0
			h=$nakagoH if p>0
			pt=[];i=0
			x=space/2
			y=space
			z=$tesuriH+$kane_tesuri_Height-$nakagoP*p-h
				pt[i]=[x,y,z];i=i+1
			z+=h
				pt[i]=[x,y,z];i=i+1
			x+=w
				pt[i]=[x,y,z];i=i+1
			z-=h
				pt[i]=[x,y,z];i=i+1
			face=entities.add_face pt
			face.reverse!
			face.followme railline
			p+=1
		end
	end
end
#//////////////////////////////////////
#/////////////  SU本体設定  ///////////
#//////////////////////////////////////

unless ( file_loaded?("FenceAndStairs.rb") )
# ツールバー
 # plugins = Sketchup.find_support_file("Plugins")
 imgdir ="FenceAndStairs"
 
 tb = UI::Toolbar.new("栏杆|楼梯")
 
 cmd = UI::Command.new("百叶栏杆") { RSfence.new.louver }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "l1.png")
 cmd.status_bar_text = cmd.tooltip = "百叶栏杆"
 tb.add_item cmd
 
 cmd = UI::Command.new("横档栏杆（样式1）") { RSfence.new.yokosan1 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "y1.png")
 cmd.status_bar_text = cmd.tooltip = "横档栏杆（样式1）"
 tb.add_item cmd
 
 cmd = UI::Command.new("横档栏杆（样式2）") { RSfence.new.yokosan2 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "y2.png")
 cmd.status_bar_text = cmd.tooltip = "横档栏杆（样式2）"
 tb.add_item cmd
 
 cmd = UI::Command.new("横档栏杆（样式3）") { RSfence.new.yokosan3 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "y3.png")
 cmd.status_bar_text = cmd.tooltip = "横档栏杆（样式3）"
 tb.add_item cmd
 
 cmd = UI::Command.new("横档栏杆（样式4）") { RSfence.new.yokosan4 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "h1.png")
 cmd.status_bar_text = cmd.tooltip = "横档栏杆（样式4）"
 tb.add_item cmd
 
 cmd = UI::Command.new("竖档栏杆（样式1）") { RSfence.new.tatesan1 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "t1.png")
 cmd.status_bar_text = cmd.tooltip = "竖档栏杆（样式1）"
 tb.add_item cmd
 
 cmd = UI::Command.new("竖档栏杆（样式2）") { RSfence.new.tatesan2 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "t2.png")
 cmd.status_bar_text = cmd.tooltip = "竖档栏杆（样式2）"
 tb.add_item cmd
 
 cmd = UI::Command.new("竖档栏杆（样式3）") { RSfence.new.tatesan3 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "t3.png")
 cmd.status_bar_text = cmd.tooltip = "竖档栏杆（样式3）"
 tb.add_item cmd
 
 cmd = UI::Command.new("栏板栏杆") { RSfence.new.panel1 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "p1.png")
 cmd.status_bar_text = cmd.tooltip = "栏板栏杆"
 tb.add_item cmd
 
 cmd = UI::Command.new("栅格栏杆") { RSfence.new.cross1 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "c1.png")
 cmd.status_bar_text = cmd.tooltip = "栅格栏杆"
 tb.add_item cmd
 
 cmd = UI::Command.new("网状栏杆") { RSfence.new.mesh1 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "m1.png")
 cmd.status_bar_text = cmd.tooltip = "网状栏杆"
 tb.add_item cmd
 
 cmd = UI::Command.new("栅栏围墙") { RSfence.new.gen_yokoyamato }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "z1.png")
 cmd.status_bar_text = cmd.tooltip = "栅栏围墙"
 tb.add_item cmd
 
 cmd = UI::Command.new("旋转楼梯") { RSfence.new.stair1 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "s1.png")
 cmd.status_bar_text = cmd.tooltip = "旋转楼梯"
 tb.add_item cmd
 
  cmd = UI::Command.new("悬臂楼梯") { RSfence.new.stair2 }
 cmd.large_icon =  cmd.small_icon = File.join(imgdir, "s2.png")
 cmd.status_bar_text = cmd.tooltip = "悬臂楼梯"
 tb.add_item cmd
 tb.show if tb.get_last_state == -1
end

 
add_separator_to_menu("Plugins")
plugins_menu=UI.menu("Plugins")
RS_menu=plugins_menu.add_submenu("栏杆|楼梯")
RS_menu.add_item("百叶栏杆") { RSfence.new.louver }
RS_menu.add_item("横档栏杆（样式1）") { RSfence.new.yokosan1 }
RS_menu.add_item("横档栏杆（样式2）") { RSfence.new.yokosan2 }
RS_menu.add_item("横档栏杆（样式3）") { RSfence.new.yokosan3 }
RS_menu.add_item("横档栏杆（样式4）") { RSfence.new.yokosan4 }
RS_menu.add_item("竖档栏杆（样式1）") { RSfence.new.tatesan1 }
RS_menu.add_item("竖档栏杆（样式2）") { RSfence.new.tatesan2 }
RS_menu.add_item("竖档栏杆（样式3）") { RSfence.new.tatesan3 }
RS_menu.add_item("栏板栏杆") { RSfence.new.panel1 }
RS_menu.add_item("栅格栏杆") { RSfence.new.cross1 }
RS_menu.add_item("网状栏杆") { RSfence.new.mesh1 }
RS_menu.add_item("栅栏围墙") { RSfence.new.gen_yokoyamato }
RS_menu.add_item("旋转楼梯") { RSfence.new.stair1 }
RS_menu.add_item("悬臂楼梯") { RSfence.new.stair2 }
file_loaded("FenceAndStairs.rb")
end #of class

fs_extension = SketchupExtension.new(
    "栏杆|楼梯", "FenceAndStairs.rb")

fs_extension.description = "日本网站上下载的几个做栏杆和楼梯的小插件，特将它们合并在一起，汉化并完善工具栏。"
fs_extension.version = "1.0"
fs_extension.creator = "随影（修改并汉化）（原作者不详)"
fs_extension.copyright = "Internet 2015"

# Register the extension with Sketchup.
Sketchup.register_extension fs_extension, true
